// RefusalTabView.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "RefusalTabView.h"
#include <aplpss.h>
#include <aplmpc.h>

// CRefusalTabView

IMPLEMENT_DYNCREATE(CRefusalTabView, CFormView)

CRefusalTabView::CRefusalTabView()
	: CFormView(CRefusalTabView::IDD)
{
	m_inst=0;
	m_api=0;
	m_expl_mgr=0;
}

CRefusalTabView::~CRefusalTabView()
{
}

void CRefusalTabView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CRefusalTabView, CFormView)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_RECT, &CRefusalTabView::OnNMDblclkListRect)
END_MESSAGE_MAP()


// CRefusalTabView diagnostics

#ifdef _DEBUG
void CRefusalTabView::AssertValid() const
{
	CFormView::AssertValid();
}

#ifndef _WIN32_WCE
void CRefusalTabView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif
#endif //_DEBUG

void CRefusalTabView::OnDestroy()
{
	if(0!=m_ListCtrl.m_hWnd)m_ListCtrl.SaveColumnWidths();
	CFormView::OnDestroy();
}


// CRefusalTabView message handlers

BOOL CRefusalTabView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext)
{
	// TODO: Add your specialized code here and/or call the base class

	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

LRESULT CRefusalTabView::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	if(message==m_update_msg) 
	{ 
		if(wParam==APL_UPDATE_INST_ITEM) 
		{ 
			CaplUpdateItem* item = (CaplUpdateItem*)lParam; 
			UpdateTreeItem(item); 
		} 
		return 0; 
	} 
	else if(message==m_disconnect_msg)
	{
		if (m_ListCtrl)
		{
			m_ListCtrl.DeleteAllItems();
			//m_ListCtrl.DeleteAllColumns();
		}
		return 0;
	}
	return CFormView::WindowProc(message, wParam, lParam);
}
//************************************************************************************************
void CRefusalTabView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();

	CRect rect;
	GetDlgItem(IDC_LIST_RECT)->GetWindowRect(rect);
	ScreenToClient(rect);
	//if(m_ListCtrl.Create(WS_BORDER|WS_CHILD|LVS_SHOWSELALWAYS|LVS_SINGLESEL,rect,this, IDC_LIST,true)!=TRUE)
	//	return;
	m_ListCtrl.CreateFromStatic(IDC_LIST_RECT,this);

	m_ListCtrl.InsertColumn(0,"",LVCFMT_LEFT,5);
	m_ListCtrl.InsertColumn(1,"",LVCFMT_RIGHT,10);
	m_ListCtrl.InsertColumn(2,"  ",LVCFMT_RIGHT,10);
	m_ListCtrl.InsertColumn(3," ",LVCFMT_LEFT,10);
	m_ListCtrl.InsertColumn(4," ",LVCFMT_CENTER,10);
	m_ListCtrl.InsertColumn(5," ",LVCFMT_CENTER,10);
	m_ListCtrl.InsertColumn(6,"",LVCFMT_CENTER,10);
	m_ListCtrl.InsertColumn(7," ",LVCFMT_CENTER,10);

	m_ListCtrl.SetUniqueName("plg_refisal_CRefusalTabView");
	m_ListCtrl.LoadColumnWidths();

}
//************************************************************************************************
void CRefusalTabView::OnSize(UINT nType, int cx, int cy)
{
	CFormView::OnSize(nType, cx, cy);

	if(0==m_ListCtrl.m_hWnd)return;

	RECT rect;
	GetClientRect(&rect);
	rect.left-=1;
	rect.right+=1;
	rect.top-=1;
	rect.bottom+=1;	
	m_ListCtrl.MoveWindow(&rect);
}

//************************************************************************************************
void CRefusalTabView::UpdateTreeItem(CaplUpdateItem *inst_item)
{
	if(inst_item==0) return;
	if(0==m_ListCtrl.m_hWnd)return;

	if(m_api != inst_item->app->m_api)
	{
		m_api = inst_item->app->m_api; 

		if(0==m_api->m_expl_mgr)
		{
			m_expl_mgr=&m_expl_mgr_local;
			m_expl_mgr->Attach(m_api);
		}
		else m_expl_mgr=m_api->m_expl_mgr;
	}

	if(m_inst==inst_item->inst) return;

	m_ListCtrl.DeleteAllItems();
	m_inst=inst_item->inst;

	int i = 0,
		item = 0;
	CString qstr = "", str = "";

	//    
	if(m_api->m_data.IsKindOf(m_inst,m_api->m_doc_mgr.e_apl_doc))
	{
		aplExtent ext_docs;
		ext_docs.Clear();
		qstr = "";
		qstr.Format("SELECT_load_all Ext FROM Ext {apl_document_reference(.assigned_document = #%i)}.assigned_document END_SELECT", m_inst->GetId());
		if (m_api->m_data.NET_QueryEditParse(qstr, 0,0))
			m_api->m_data.NET_QueryExecute(ext_docs,0);

		CaplLoadData ld(&m_api->m_data);	
		ld.ClearQuery();	
		for(int i = 0; i < ext_docs.GetSize(); ++i)
		{
			if(0 != ext_docs[i]) ld.AddQuery(0, ext_docs[i],true);
		}
		int irefer = ld.AddQuery('r', 0, m_api->m_doc_mgr.e_apl_doc_ref, m_api->m_doc_mgr.a_apl_doc_ref_doc, true, true); 
    	         int irefus = ld.AddQuery('d', irefer, m_api->m_doc_mgr.e_apl_doc_ref, m_api->m_doc_mgr.a_apl_doc_ref_item, true, true); 
	
		int iappr_dig_doc = ld.AddQuery('r', 0, (const char *)"apl_digital_document", (const char *)"of_document", true, true);
	       int iappr_status = ld.AddQuery('r', iappr_dig_doc, m_api->m_appr_mgr.e_apl_appr_pers_org, m_api->m_appr_mgr.a_appr_item, true, true);	
		                      ld.AddQuery('d', iappr_status,  m_api->m_appr_mgr.e_apl_appr_pers_org, m_api->m_appr_mgr.a_appr_status, true, true);	
		ld.LoadEx();
		int irow = 0;
		irow = m_ListCtrl.GetItemCount();
		for (int id = 0; id < ext_docs.GetSize(); ++id)
		{
			aplExtent ext_ref_doc;
			ext_ref_doc.Clear();
			m_api->m_data.FindInstanceUsers(ext_docs[id], m_api->m_doc_mgr.e_apl_doc_ref, m_api->m_doc_mgr.a_apl_doc_ref_doc, ext_ref_doc);
			for (int ir = 0; ir < ext_ref_doc.GetSize(); ++ir)
			{
				CaplInstance *inst = NULL;
				if (m_api->m_data.GetAttr(ext_ref_doc[ir], m_api->m_doc_mgr.a_apl_doc_ref_item, inst))
					if (inst != NULL)
					{
						str = "";
						if (m_api->m_data.IsKindOf(inst, m_expl_mgr->e_apl_refusal))
						{
							++irow;
							str.Format("%.i", id + 1);
							item = m_ListCtrl.InsertItem(irow, str);
							m_ListCtrl.SetItemData(item,(long)inst);

							m_api->m_data.GetAttr(ext_docs[id], m_api->m_doc_mgr.a_doc_id, str); //  
							m_ListCtrl.SetItemText(item, 1, str);
							m_api->m_data.GetAttr(inst, m_expl_mgr->a_apl_refusal_doc_num, str);
							m_ListCtrl.SetItemText(item, 2, str);
				
							m_api->m_data.GetAttr(inst, m_expl_mgr->a_apl_refusal_description, str);
							m_ListCtrl.SetItemText(item, 3, str);

							m_api->m_data.GetAttr(inst, m_expl_mgr->a_apl_refusal_date_detection, str);
							COleDateTime Tdate;
							aplString2Date(str, Tdate);
							str = Tdate.Format(_T("%d.%m.%y"));
							m_ListCtrl.SetItemText(item, 4, str);

							m_api->m_data.GetAttr(inst, m_expl_mgr->a_apl_refusal_date_removal, str);
							aplString2Date(str, Tdate);
							str = Tdate.Format(_T("%d.%m.%y"));
							m_ListCtrl.SetItemText(item, 5, str);
						}// if (m_api.m_data.IsKindOf(item, m_expl_mgr.e_apl_refusal))
					}// if (item != NULL)
			}// for (int ir = 0; ir < ext_ref_doc.GetSize(); ++ir)
			aplExtent ext_ref_didoc;
			ext_ref_didoc.Clear();
			m_api->m_data.FindInstanceUsersBN(ext_docs[id], (const char *)"apl_digital_document", (const char *)"of_document", ext_ref_didoc);
			for (int idd = 0; idd < ext_ref_didoc.GetSize(); ++idd)
			{
				aplExtent ext_appr_items;
				ext_appr_items.Clear();
				CString date = "", 
					    date_last = "",
					    state = "";
				m_api->m_data.FindInstanceUsers(ext_ref_didoc[idd], m_api->m_appr_mgr.e_apl_appr_pers_org, m_api->m_appr_mgr.a_appr_item, ext_appr_items);
				for (int iapp = 0; iapp < ext_appr_items.GetSize(); ++iapp)
				{
					m_api->m_data.GetAttr(ext_appr_items[iapp], m_api->m_appr_mgr.a_appr_appr_date_time_s, str);
					if (str > date_last)
					{
						date_last = str;
						CaplInstance * status = NULL;
						m_api->m_data.GetAttr(ext_appr_items[iapp], m_api->m_appr_mgr.a_appr_status, status);
						if (status != NULL)
						{
							m_api->m_data.GetAttr(status, m_api->m_appr_mgr.a_appr_status_name, state);
						}
					}
					date = date + "/n" + str;
				}
				COleDateTime Tdate;
				aplString2Date(date_last, Tdate);
				date_last = Tdate.Format(_T("%d.%m.%y"));
				m_ListCtrl.SetItemText(item, 6, state);//  
				m_ListCtrl.SetItemText(item, 7, date_last);//  
			}// for (int idd = 0; idd < ext_ref_didoc.GetSize(); ++idd)
		} // for (int id = 0; id < ext_docs.GetSize(); ++id)
		
	} // if(m_api->m_data.IsKindOf(m_inst,m_api->m_doc_mgr.e_apl_doc))
		
	//  
	else if ((m_api->m_data.IsKindOf(m_inst,m_api->m_prd_mgr.e_apl_pdf)) || (m_api->m_data.IsKindOf(m_inst,m_api->m_prd_mgr.e_prd)))
	{
		aplExtent ext_refusals;
		ext_refusals.Clear();
		qstr = "";
		if (m_api->m_data.IsKindOf(m_inst,m_api->m_prd_mgr.e_prd))
			m_inst = m_api->m_prd_mgr.FindPdfById(m_inst, "");
		qstr.Format("SELECT_load_all Ext_1 or Ext_2 or Ext_3 FROM Ext_1 {apl_refusal(.planer->apl_product_instance.formation = #%i)} \
                     Ext_2 {apl_refusal(.item->apl_product_instance.formation = #%i)}    \
                     Ext_3 {apl_refusal(.part->apl_product_instance.formation = #%i )} END_SELECT", m_inst->GetId(), m_inst->GetId(), m_inst->GetId());
		if (m_api->m_data.NET_QueryEditParse(qstr, 0,0))
			m_api->m_data.NET_QueryExecute(ext_refusals,0);

		int irow = 0;
		irow = m_ListCtrl.GetItemCount();
		for (int ir = 0; ir < ext_refusals.GetSize(); ++ir)
		{
			++irow;
			str.Format("%.i", ir + 1);
			item = m_ListCtrl.InsertItem(irow, str);
			m_ListCtrl.SetItemData(item,(long)ext_refusals[ir]);

			CString str_name = "";
			m_api->m_prd_mgr.GetItemName(m_inst, str_name);
			//m_api->m_data.GetAttr(, m_api->m_doc_mgr.a_doc_id, str); //  
			m_ListCtrl.SetItemText(item, 1, str_name);
			m_api->m_data.GetAttr(ext_refusals[ir], m_expl_mgr->a_apl_refusal_doc_num, str);
			m_ListCtrl.SetItemText(item, 2, str);
				
			m_api->m_data.GetAttr(ext_refusals[ir], m_expl_mgr->a_apl_refusal_description, str);
			m_ListCtrl.SetItemText(item, 3, str);

			m_api->m_data.GetAttr(ext_refusals[ir], m_expl_mgr->a_apl_refusal_date_detection, str);
			COleDateTime Tdate;
			aplString2Date(str, Tdate);
			str = Tdate.Format(_T("%d.%m.%y"));
			m_ListCtrl.SetItemText(item, 4, str);

			m_api->m_data.GetAttr(ext_refusals[ir], m_expl_mgr->a_apl_refusal_date_removal, str);
			aplString2Date(str, Tdate);
			str = Tdate.Format(_T("%d.%m.%y"));
			m_ListCtrl.SetItemText(item, 5, str);

		}
		

	}
	//  
	else if (m_api->m_data.IsKindOf(m_inst,m_api->m_prd_inst_mgr.e_prd_inst))
	{
		aplExtent ext_refusals;
		ext_refusals.Clear();
		qstr = "";
	
		qstr.Format("SELECT_load_all Ext_1 or Ext_2 or Ext_3 FROM Ext_1 {apl_refusal(.planer->apl_product_instance.# = #%i)} \
				                                               	  Ext_2 {apl_refusal(.item->apl_product_instance.# = #%i)}    \
					                                              Ext_3 {apl_refusal(.part->apl_product_instance.# = #%i )} END_SELECT", m_inst->GetId(), m_inst->GetId(), m_inst->GetId());
		if (m_api->m_data.NET_QueryEditParse(qstr, 0,0))
			m_api->m_data.NET_QueryExecute(ext_refusals,0);
	//	MessageBox(qstr);

		int irow = 0;
		irow = m_ListCtrl.GetItemCount();
		for (int ir = 0; ir < ext_refusals.GetSize(); ++ir)
		{
			++irow;
			str.Format("%.i", ir + 1);
			item = m_ListCtrl.InsertItem(irow, str);
			m_ListCtrl.SetItemData(item,(long)ext_refusals[ir]);

			CString str_name = "";
			m_api->m_prd_inst_mgr.GetItemName(m_inst, str_name);
			//m_api->m_data.GetAttr(, m_api->m_doc_mgr.a_doc_id, str); //  
			m_ListCtrl.SetItemText(item, 1, str_name);
			m_api->m_data.GetAttr(ext_refusals[ir], m_expl_mgr->a_apl_refusal_doc_num, str);
			m_ListCtrl.SetItemText(item, 2, str);
				
			m_api->m_data.GetAttr(ext_refusals[ir], m_expl_mgr->a_apl_refusal_description, str);
			m_ListCtrl.SetItemText(item, 3, str);

			m_api->m_data.GetAttr(ext_refusals[ir], m_expl_mgr->a_apl_refusal_date_detection, str);
			COleDateTime Tdate;
			aplString2Date(str, Tdate);
			str = Tdate.Format(_T("%d.%m.%y"));
			m_ListCtrl.SetItemText(item, 4, str);

			m_api->m_data.GetAttr(ext_refusals[ir], m_expl_mgr->a_apl_refusal_date_removal, str);
			aplString2Date(str, Tdate);
			str = Tdate.Format(_T("%d.%m.%y"));
			m_ListCtrl.SetItemText(item, 5, str);

		}

	}


}

DWORD m_PID_accounts_faults=0;

void StartAccountingFault(const char* command, CaplAPI *m_api)
{
	//m_api->m_data.ShowInstancesDebugInfo(inst);
	if(0!=m_PID_accounts_faults && CaplMPC::IsPpocessActive(m_PID_accounts_faults))
	{
		CaplMPC mpc;
		bool b=mpc.SendCommand(m_PID_accounts_faults,command);	
		return;
	}

	m_PID_accounts_faults=0;

	CString buf,psw,sCmdLine="* ";
	sCmdLine+="\""; sCmdLine+="/user="; sCmdLine+=m_api->m_data.GetNameCurrUser(); sCmdLine+="\"";
	m_api->m_data.NET_GetString4DupSession(psw);
	sCmdLine+=" \""; sCmdLine+="/password="; sCmdLine+=psw; sCmdLine+="\"";
	sCmdLine+=" \""; sCmdLine+="/db="; sCmdLine+=m_api->m_data.GetNameCurrConnection(); sCmdLine+="\"";

	sCmdLine+=" "; sCmdLine+=command;

	m_PID_accounts_faults=CaplMPC::StartProcess("AccountingFaults.exe",sCmdLine);
	//m_PID_accounts_faults=CaplMPC::StartProcess("AccountingFaults.exe","* /user=Administrator \"/db=DEMO-3 \" /password= /showinst=#54206");
}



void CRefusalTabView::OnNMDblclkListRect(NMHDR *pNMHDR, LRESULT *pResult)
{
	
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	// TODO: Add your control notification handler code here
	*pResult = 0;

	if(0==pNMItemActivate) return;

	CaplInstance *inst=(CaplInstance *)m_ListCtrl.GetItemData(pNMItemActivate->iItem);
	///**************************************
	/*CString str = "";
	str.Format("%.i", pNMItemActivate->iItem);
	MessageBox(str);
	if (inst == NULL) MessageBox("NULL");*/
	// ***************************************
	if(0==inst) return;
	CString buf;
	buf.Format("$showinst=#%i",inst->GetId());
	StartAccountingFault(buf,m_api);
	return;
}
