#include "stdafx.h"
#include "RefusalTabView.h"
#include <aplWorkFlowManager.h>

extern HINSTANCE _hDllInstance;

char *plug_name = "  ";
char *plug_descr = "     PDM";

class CaplResChanger
{
	HINSTANCE m_h;
public:
	CaplResChanger()
	{
		m_h = AfxGetResourceHandle();
		AfxSetResourceHandle(_hDllInstance);
	}
	~CaplResChanger(){	AfxSetResourceHandle(m_h);}
};

//************************************************************************
__declspec(dllexport) char* GetAddInName() {return plug_name; }
__declspec(dllexport) char* GetAddInDescription() {return plug_descr;}


CaplItemInfo functionArray []=
{
	CaplItemInfo(aplPopUp, "Task", "[1]\\[-1] ", "add_Fault", -1, -1),
	CaplItemInfo(aplPopUp, "Process", "[1]\\[-1] ", "add_Fault", -1, -1),
};


//************************************************************************
__declspec(dllexport) bool GetFunctionsList(CArray<CaplItemInfo*, CaplItemInfo*> *strArray)
{
	int functionArraySize= sizeof(functionArray)/sizeof(CaplItemInfo);
	for(int i= 0; i<functionArraySize; i++)
	{
		strArray->Add(&functionArray[i]);
	}
	return true;
}

//************************************************************************
__declspec(dllexport) bool CreateTabViewsEx(CWnd* parent, RECT Rect, UINT *msg, CaplAddinViews *views)
{
	/*  msg
	1 - Update Tree Item
	2 - Disconnect Message
	*/
	if(views==0) return true;
	if(parent==0) return false;
	if(msg<0) return false;
	CRefusalTabView* view = (CRefusalTabView*)(RUNTIME_CLASS(CRefusalTabView)->CreateObject());
	if(view==0) return false;
	CaplResChanger  ResChanger;
	view->Create(0,0,0,Rect,parent,IDD_REFUSALTABVIEW,NULL);
	HICON ico=LoadIcon(_hDllInstance,MAKEINTRESOURCE(IDI_REFTAB));
	if(ico!=0) view->SetIcon(ico,FALSE);
	view->OnInitialUpdate();
	view->ShowWindow(SW_HIDE);
	view->m_update_msg = msg[0];
	view->m_disconnect_msg = msg[1];
	views->AddView(view, /*APL_FOLDER_ITEM|APL_TREE_ITEM_PRDINST|*/APL_PRD_INST_ITEM|APL_PDF_ITEM|APL_PRD_ITEM|APL_DOC_ITEM, 1, "", "  ");
	return true;
}

__declspec(dllexport) bool GetTabViews(CaplAddinViews *views) //      
{
	views->AddView(0, /*APL_FOLDER_ITEM|APL_TREE_ITEM_PRDINST|*/APL_PRD_INST_ITEM|APL_PDF_ITEM|APL_PRD_ITEM|APL_DOC_ITEM, 1, "", "  ");
	return true;
}


// ,    



/*
void UpdateDlg(CMyWinThread* procThread, CString sTitle, 
			   int iProgress, int count, bool bUpdate)
{
	MSG msg;
	while (::PeekMessage(&msg, NULL, WM_PAINT, WM_PAINT, PM_REMOVE|PM_NOYIELD))DispatchMessage(&msg);
	
	CString sProgress;
	sProgress.Format(" : %i", count);
	procThread->m_sPrimText= sTitle;
	procThread->m_sSecoText= sProgress;
	procThread->m_iCurProgressPos= iProgress;
	procThread->Update(bUpdate);
}
*/

/*
//************************************************************************
__declspec (dllexport) bool add_DeleteLabels(CaplAPI* api, 
								aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || !api->m_data.IsConnected()) return false;

	if(!bUpdateUI)
	{
		//   
		CaplResChanger  ResChanger;
	}

	return true;	
}*/

extern void StartAccountingFault(const char* command, CaplAPI *m_api);

__declspec (dllexport) bool add_Fault(CaplAPI* api,  aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || !api->m_data.IsConnected()) return false;

	if(inExtent.GetSize()<1) return false;

	if(!bUpdateUI)
	{
		api->LoadExtentInfo(inExtent);

		CaplWorkFlowManager *wf_mgr=(CaplWorkFlowManager *)api->m_wf_mgr;
		if(0==wf_mgr) return false;

		CaplInstance *inst=inExtent[0];
		if(0==inst) return false;

		if(api->m_data.IsKindOf(inst,wf_mgr->e_task))
		{
			api->m_data.GetAttr(inst,wf_mgr->a_task_proc,inst);
			if(0==inst) return false;
		}

		if(!api->m_data.IsKindOf(inst,wf_mgr->e_proc))return false;

		aplExtent ext_items;

		CString buf,sDocs;
		api->m_data.GetAttr(inst,wf_mgr->a_proc_wo,ext_items);
		int i;
		for(i=0;i<ext_items.GetSize();i++)
		{
			CaplInstance *inst1=ext_items[i];
			api->m_data.GetAttr(inst1,wf_mgr->a_wo_object,inst1);
			if(!api->m_data.IsKindOf(inst1,api->m_doc_mgr.e_doc)) continue;
			if(sDocs!="") sDocs+=",";
			buf.Format("%i",inst1->GetId());
			sDocs+=buf;
		}

		CString cmd="$new";
		if(sDocs!="") {cmd+=" adddocs="; cmd+=sDocs;}
		StartAccountingFault(cmd,api);
		return true;
	}
	return true;

}